/**********************************************************************
*   Golden Measure for YODA-ASG
*   Sequential processing algorithm to generate arithmetic sequences.
*
***********************************************************************/

#include "main.h"

/**********************************************************************/

                    /****************************
                    * Version 2 (No data storing)
                    *****************************/

int main(int argc, char *argv[]){

    const unsigned int a1 = 255;
    const unsigned int n = 1000000000;
    const unsigned int d = 10;

    double time = 0.0;
    const int iterations = 5;

    for(int i=0;i<iterations;i++){
        time += generateSequence2(a1,n,d);
    }
    printf("Average Runtime = %lg ms\n", (time/iterations));

    return 0;
}

double generateSequence2(unsigned int a1, unsigned int n, unsigned int d){

    double  tend = 0.0;
    unsigned long data;
    tic();
    for(int i=1; i<=n; i++){
        data = a1 + (i-1)*d;
    }
    tend = toc()/1e-3;
    printf("Runtime = %lg ms\n", tend);

    return tend;
}

/**********************************************************************/
                        /****************************
                        *   Version (Data storing)
                        *****************************/

/*
#include "main.h"

int main(int argc, char *argv[]){

    const unsigned int a1 = 15;
    const unsigned int n = 400000000; //400000000
    const unsigned int d = 707;

    unsigned int* a = (unsigned int*)calloc(n, sizeof(unsigned int));
    double time = 0.0;
    const int iterations = 10;

    for(int i=0;i<iterations;i++){
        time += generateSequence(a1,n,d,a);
    }
    printf("Average Runtime = %lg ms\n", (time/iterations));
    printf("%d", a[n-1]);

    return 0;
}

double generateSequence(unsigned int a1, unsigned int n, unsigned int d, unsigned int* store){

    double  tend = 0.0;

    tic();
    for(int i=1; i<=n; i++){
        store[i-1] = a1 + (i-1)*d;
    }
    tend = toc()/1e-3;
    printf("Runtime = %lg ms\n", tend);

    return tend;
}
*/
/**********************************************************************/
