`timescale 1ns / 1ps
module ControlUnit(
	output done,
	output [31:0] groupOffset,
	output validOut,
	output [4:0]memAddrOut,
	input [31:0]n,
	input activate,
	input [15:0] M,
	input clock
);

reg [31:0]counter;
reg [4:0]memAddr;
reg doneReg, validReg;

assign groupOffset = counter;
assign memAddrOut = memAddr;
assign done = doneReg;
assign validOut = validReg;

always @(posedge clock) begin
	if(activate) begin
		doneReg <= 1'b0;
		counter <= 64'b0;
	end
	else begin
		if(~doneReg)
		begin
			if(counter > n + (12*M))
			begin
				doneReg <= 1'b1;
				counter <= 0;
				memAddr <= 0;
				validReg <= 1'b0;
			end
			else begin
				counter <= counter + M;
				memAddr <= memAddr + 1'b1;
				validReg <= 1'b1;
			end
		end
	end
end

endmodule
