`timescale 1ns / 1ps

module FullAdder16(
	output[15:0] sum,
	output carryOut,
	input [15:0] inA,
	input [15:0] inB,
	input carryIn
	);
	 
	 wire carry0, carry1, carry2, carry3;
	 assign carryOut = carry3;
	 FullAdder4 fa0(.inA(inA[3:0]), .inB(inB[3:0]), .carryIn(carryIn), .carryOut(carry0));
	 FullAdder4 fa1(.inA(inA[7:4]), .inB(inB[7:4]), .carryIn(carry0), .carryOut(carry1));
	 FullAdder4 fa2(.inA(inA[11:8]), .inB(inB[11:8]), .carryIn(carry1), .carryOut(carry2));
	 FullAdder4 fa3(.inA(inA[15:12]), .inB(inB[15:12]), .carryIn(carry2), .carryOut(carry3));
endmodule
