`timescale 1ns / 1ps
module OffsetBlock(
	output [31:0] i,
	output validOut,
	output [4:0]memAddrOut,
	input [15:0] groupOffset, 
	input validIn,
	input [15:0]N,
	input [4:0]memAddrIn,
	input clock
);

reg validInReg, validOutReg;
reg [15:0]groupOffsetInReg, iOutReg; 
reg [4:0] memAddrInReg, memAddrOutReg;

wire validBetweenReg;
wire [4:0]memAddrBetweenReg;
wire [15:0]offsetBeforeAdder;
wire [31:0]sum;

// First pipeline stage:
always @(posedge clock) begin
	validInReg <= validIn;
	groupOffsetInReg <= groupOffset;
	memAddrInReg <= memAddrIn;
end

assign validBetweenReg = validInReg;
assign offsetBeforeAdder = groupOffsetInReg;
assign memAddrBetweenReg = memAddrInReg;

assign sum = N + offsetBeforeAdder;

// Second pipeline stage:
always @(posedge clock) begin
	validOutReg <= validBetweenReg;
	memAddrOutReg <= memAddrBetweenReg;
	iOutReg <= sum;
end

assign i = iOutReg;
assign validOut = validOutReg;
assign memAddrOut = memAddrOutReg;

endmodule
